package com.iformall.controller.msg;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.base.BaseEntity;
import com.iformall.domain.po.WxMsgSignature;
import com.iformall.service.WxMsgSignatureService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("wxMsgSignature")
public class WxMsgSignatureController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxMsgSignatureService wxMsgSignatureService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "消息签名-列表")
    public ResultData list(@ModelAttribute WxMsgSignature wxMsgSignature, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxMsgSignatureController::list");
        if (null == wxMsgSignature) wxMsgSignature = new WxMsgSignature();
        wxMsgSignature.setTenantId(getTenantId());
        wxMsgSignature.setSortColumns(BaseEntity.SortField.Createtime_DESC);
        final PageInfo<WxMsgSignature> page = wxMsgSignatureService.listAsPage(wxMsgSignature, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "消息签名-新增")
    public ResultData add(@RequestBody WxMsgSignature wxMsgSignature) {
        logger.debug("[" + getIpAddr() + "] WxMsgSignatureController::add");
        //Assert.notNull(wxMsgSignature.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxMsgSignature.setTenantId(getTenantId());
        wxMsgSignatureService.saveOrUpdate(wxMsgSignature);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "消息签名-更新")
    public ResultData update(@RequestBody WxMsgSignature wxMsgSignature) {
        logger.debug("[" + getIpAddr() + "] WxMsgSignatureController::update");
        wxMsgSignatureService.saveOrUpdate(wxMsgSignature);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "消息签名-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMsgSignatureController::delete");
        wxMsgSignatureService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "消息签名-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMsgSignatureController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxMsgSignatureService.getById(id));
    }

    @ApiOperation("获取所有数据")
    @GetMapping("getsignaturelist")
    @SystemControllerLog(description = "消息签名-获取所有")
    public ResultData getmodellist() {
        logger.debug("[" + getIpAddr() + "] WxMsgSignatureController::getmodellist");
        return wxMsgSignatureService.getsignaturelist(getTenantId());
    }


}
